﻿SET client_encoding = 'UTF8';

CREATE OR REPLACE FUNCTION public.ol_toch_ins (
)
RETURNS trigger AS
$body$
DECLARE
  idu INTEGER;
  ngeom geometry;
  idt INTEGER;
  pob INTEGER;
  idparent INTEGER;
  maxnomer INTEGER;
  part SMALLINT;

BEGIN
  idu   = NEW.id_uchastok;
  ngeom = NEW.geom;
  pob   = NEW.poryadok_obhoda;
  part  = NEW.nomer_chasti;
-- проверка существования точки у данного ЗУ с такой же геометрией
-- если есть такая точка, тогда только меняется порядок обхода, но INSERT NEW не происходит
  SELECT id FROM msk.tochka WHERE (id_uchastok = idu) AND (public.st_equals(ngeom, geom)) INTO idt;

  IF (idt > 0) THEN
    IF (pob > 0) THEN
--      UPDATE msk.tochka SET poryadok_obhoda = pob WHERE id = idt;
      UPDATE msk.tochka SET (poryadok_obhoda, nomer_chasti) = (pob, part) WHERE id = idt;
    END IF;
    RETURN NULL;
    
  ELSE
-- для новых точек корректируем нумерацию  
    IF NEW.prefiks_nomera = 'н' THEN
      SELECT id_parent FROM public.parcel_parcel WHERE id_children = idu INTO idparent;

      IF (idparent IS NOT NULL) THEN
        SELECT MAX(nomer) FROM msk.tochka 
          WHERE id_uchastok IN (SELECT id_children FROM public.parcel_parcel WHERE (id_parent = idparent))
            AND (prefiks_nomera = 'н') INTO maxnomer;
      ELSE
        SELECT MAX(nomer) FROM msk.tochka WHERE (id_uchastok = idu) AND (prefiks_nomera = 'н') INTO maxnomer;
      END IF;  
      
      IF (maxnomer IS NULL) THEN
        NEW.nomer = 1;
      ELSE
        NEW.nomer = maxnomer + 1;
      END IF;
    END IF;  

    RETURN NEW;

  END IF;  
  
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
COST 100;


ALTER TABLE msk.tochka
  ALTER COLUMN podpis_x TYPE CHAR(17)
    USING cast(cast(podpis_x as INTEGER) as CHARACTER(17));

ALTER TABLE msk.tochka
  ALTER COLUMN podpis_y TYPE CHAR(17)
    USING cast(cast(podpis_y as INTEGER) as CHARACTER(17));

ALTER TABLE msk.uchastok
  ALTER COLUMN podpis_x TYPE CHAR(17)
    USING cast(cast(podpis_x as INTEGER) as CHARACTER(17));

ALTER TABLE msk.uchastok
  ALTER COLUMN podpis_y TYPE CHAR(17)
    USING cast(cast(podpis_y as INTEGER) as CHARACTER(17));


INSERT INTO class.sistema_koordinat (id, znachenie, zona, definition) VALUES ('9587bdb7-e1a9-4573-8d64-867dd44d6dcf', 'МСК - субъект 23', 'МСК-23 зона 1 ГОСТ Р 51794—2008', '+proj=tmerc +lat_0=0 +lon_0=37.98333333333 +k=1 +x_0=1300000 +y_0=-4511057.628 +ellps=krass +towgs84=23.57,-140.95,-79.8,0,0.35,0.79,-0.22 +units=m +no_defs');
INSERT INTO class.sistema_koordinat (id, znachenie, zona, definition) VALUES ('ffea624a-af9a-4cde-93c5-6a4dff782489', 'МСК - субъект 23', 'МСК-23 зона 2 ГОСТ Р 51794—2008', '+proj=tmerc +lat_0=0 +lon_0=40.98333333333 +k=1 +x_0=2300000 +y_0=-4511057.628 +ellps=krass +towgs84=23.57,-140.95,-79.8,0,0.35,0.79,-0.22 +units=m +no_defs');
INSERT INTO class.sistema_koordinat (id, znachenie, zona, definition) VALUES ('e57c79a6-1945-47a1-8d5f-364c448e275a', 'МСК - субъект 30', 'МСК-30 зона 1 ГОСТ Р 51794—2008', '+proj=tmerc +lat_0=0 +lon_0=46.05 +k=1 +x_0=1300000 +y_0=-4714743.504 +ellps=krass +towgs84=23.57,-140.95,-79.8,0,0.35,0.79,-0.22 +units=m +no_defs');
INSERT INTO class.sistema_koordinat (id, znachenie, zona, definition) VALUES ('d2253bed-1b2c-4955-beed-7fa7729c7a27', 'МСК - субъект 30', 'МСК-30 зона 2 ГОСТ Р 51794—2008', '+proj=tmerc +lat_0=0 +lon_0=49.05 +k=1 +x_0=2300000 +y_0=-4714743.504 +ellps=krass +towgs84=23.57,-140.95,-79.8,0,0.35,0.79,-0.22 +units=m +no_defs');
INSERT INTO class.sistema_koordinat (id, znachenie, zona, definition) VALUES ('4a53af84-d1ba-40b7-91ef-3e1e642e109d', 'МСК - субъект 61', 'МСК-61 зона 1 ГОСТ Р 51794—2008', '+proj=tmerc +lat_0=0 +lon_0=37.98333333333 +k=1 +x_0=1300000 +y_0=-4811057.628 +ellps=krass +towgs84=23.57,-140.95,-79.8,0,0.35,0.79,-0.22 +units=m +no_defs');
INSERT INTO class.sistema_koordinat (id, znachenie, zona, definition) VALUES ('a82990a9-82ea-4634-bb0e-6fbdef423f19', 'МСК - субъект 61', 'МСК-61 зона 2 ГОСТ Р 51794—2008', '+proj=tmerc +lat_0=0 +lon_0=40.98333333333 +k=1 +x_0=2300000 +y_0=-4811057.628 +ellps=krass +towgs84=23.57,-140.95,-79.8,0,0.35,0.79,-0.22 +units=m +no_defs');
INSERT INTO class.sistema_koordinat (id, znachenie, zona, definition) VALUES ('0603affc-1c2d-41bb-b19b-ea05031d4f26', 'МСК - субъект 61', 'МСК-61 зона 3 ГОСТ Р 51794—2008', '+proj=tmerc +lat_0=0 +lon_0=43.98333333333 +k=1 +x_0=3300000 +y_0=-4811057.628 +ellps=krass +towgs84=23.57,-140.95,-79.8,0,0.35,0.79,-0.22 +units=m +no_defs');
INSERT INTO class.sistema_koordinat (id, znachenie, zona, definition) VALUES ('4d8eb064-e5de-4861-b613-36e32e9a7076', 'МСК - субъект 74', 'МСК-74 зона 1 ГОСТ Р 51794—2008', '+proj=tmerc +lat_0=0 +lon_0=58.03333333333 +k=1 +x_0=1300000 +y_0=-5509414.70 +ellps=krass +towgs84=23.57,-140.95,-79.8,0,0.35,0.79,-0.22 +units=m +no_defs');
INSERT INTO class.sistema_koordinat (id, znachenie, zona, definition) VALUES ('9de71609-8317-4123-beae-22f007b11fe0', 'МСК - субъект 74', 'МСК-74 зона 2 ГОСТ Р 51794—2008', '+proj=tmerc +lat_0=0 +lon_0=61.03333333333 +k=1 +x_0=2300000 +y_0=-5509414.70 +ellps=krass +towgs84=23.57,-140.95,-79.8,0,0.35,0.79,-0.22 +units=m +no_defs');
INSERT INTO class.sistema_koordinat (id, znachenie, zona, definition) VALUES ('5d51cf9d-b58c-4e57-bcc7-ffe96e74f332', 'МСК - субъект 74', 'МСК-74 зона 3 ГОСТ Р 51794—2008', '+proj=tmerc +lat_0=0 +lon_0=64.03333333333 +k=1 +x_0=3300000 +y_0=-5509414.70 +ellps=krass +towgs84=23.57,-140.95,-79.8,0,0.35,0.79,-0.22 +units=m +no_defs');

UPDATE class.database_version SET (number_version, date_version) = (18, '2014-04-11');